import { autocompletion as B, completionKeymap as D, closeBrackets as z, closeBracketsKeymap as A } from "@codemirror/autocomplete";
import { indentWithTab as K, insertNewline as V } from "@codemirror/commands";
import { css as G } from "@codemirror/lang-css";
import { html as P } from "@codemirror/lang-html";
import { json as q } from "@codemirror/lang-json";
import { xml as F } from "@codemirror/lang-xml";
import { yaml as J } from "@codemirror/lang-yaml";
import { syntaxHighlighting as U, defaultHighlightStyle as W, indentOnInput as Q, bracketMatching as x, foldGutter as E } from "@codemirror/language";
import { linter as X } from "@codemirror/lint";
import { StateEffect as Y } from "@codemirror/state";
import { EditorView as h, highlightSpecialChars as Z, keymap as u, placeholder as _, lineNumbers as $ } from "@codemirror/view";
import { ScalarIcon as C } from "@scalar/components";
import { ref as ee, watch as p, onBeforeUnmount as te, toValue as t, computed as oe, h as M, render as S } from "vue";
import { customTheme as re } from "../themes/index.js";
import { variables as ne } from "./variables.js";
const a = (e) => "provider" in e && !!t(e.provider), ie = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, xe = (e) => {
  const n = ee(null);
  p(
    e.codeMirrorRef,
    () => {
      var o;
      (o = n.value) == null || o.destroy(), c();
    },
    { immediate: !0 }
  ), te(() => {
    var o;
    return (o = n.value) == null ? void 0 : o.destroy();
  });
  function c() {
    if (e.codeMirrorRef.value) {
      const o = a(e) ? t(e.provider) : null, m = T({
        ...f.value,
        provider: o
      });
      n.value = new h({
        parent: e.codeMirrorRef.value,
        extensions: m
      }), a(e) || l(t(e.content));
    }
  }
  const f = oe(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    disableTabIndent: t(e.disableTabIndent),
    language: t(e.language),
    classes: t(e.classes),
    readOnly: t(e.readOnly),
    lineNumbers: t(e.lineNumbers),
    withVariables: t(e.withVariables),
    forceFoldGutter: t(e.forceFoldGutter),
    disableEnter: t(e.disableEnter),
    disableCloseBrackets: t(e.disableCloseBrackets),
    withoutTheme: t(e.withoutTheme),
    lint: t(e.lint),
    additionalExtensions: t(e.extensions),
    placeholder: t(e.placeholder)
  }));
  p(
    () => a(e) ? t(e.provider) : null,
    () => {
      var o;
      a(e) && ((o = n.value) == null || o.destroy(), c());
    }
  ), p(
    f,
    () => {
      if (n.value) {
        const o = a(e) ? t(e.provider) : null, m = T({
          ...f.value,
          provider: o
        });
        requestAnimationFrame(() => {
          var g;
          (g = n.value) == null || g.dispatch({
            effects: Y.reconfigure.of(m)
          });
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const l = (o = "") => {
    n.value && n.value.state.doc.toString() !== o && n.value.dispatch({
      changes: {
        from: 0,
        to: n.value.state.doc.length,
        insert: o
      },
      selection: {
        anchor: Math.min(
          n.value.state.selection.main.anchor,
          o.length
        )
      }
    });
  };
  return p(
    () => t(e.content),
    () => {
      a(e) || l(t(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: l,
    /** Codemirror instance */
    codeMirror: n
  };
}, w = {
  html: P,
  json: q,
  yaml: J,
  css: G,
  xml: F
};
function T({
  onChange: e,
  onBlur: n,
  onFocus: c,
  provider: f,
  language: l,
  classes: o = [],
  readOnly: m = !1,
  lineNumbers: g = !1,
  withVariables: N = !1,
  forceFoldGutter: v = !1,
  disableEnter: O = !1,
  disableCloseBrackets: H = !1,
  disableTabIndent: I = !1,
  withoutTheme: L = !1,
  lint: R = !1,
  additionalExtensions: j = [],
  placeholder: b
}) {
  const r = [
    Z(),
    U(W, { fallback: !0 }),
    h.theme({
      ".cm-line": {
        lineHeight: "20px",
        padding: "0 2px 0 4px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      },
      ".cm-tooltip": {
        border: "1px solid #f5c6cb",
        fontSize: "12px"
      },
      ".cm-tooltip-lint": {
        backgroundColor: "#ffffff"
      },
      ".cm-diagnostic-error": {
        borderLeft: "0",
        color: "#dc1b19"
      },
      ".cm-foldPlaceholder": {
        background: "var(--scalar-background-1)",
        border: "none",
        fontFamily: "var(--scalar-font)"
      }
    }),
    // Listen to updates
    h.updateListener.of((s) => {
      s.docChanged && (e == null || e(s.state.doc.toString()));
    }),
    h.domEventHandlers({
      blur: (s, i) => {
        n == null || n(i.state.doc.toString());
      },
      focus: (s, i) => {
        c == null || c(i.state.doc.toString());
      }
    }),
    // Add Classes
    h.editorAttributes.of({ class: o.join(" ") }),
    ...j
  ];
  if (f && r.push(f), L || r.push(re), m ? r.push(h.editable.of(!1)) : (r.push(
    Q(),
    x(),
    B(),
    u.of([...D, ie]),
    x()
  ), H || r.push(z(), u.of([...A])), I ? r.push(
    u.of([
      {
        key: "Tab",
        run: () => !1,
        // Prevent default Tab behavior
        shift: () => !1
        // Prevent default Shift+Tab behavior
      }
    ])
  ) : r.push(u.of([K]))), b && r.push(_(b)), g && r.push($()), v && r.push(
    E({
      markerDOM: (s) => {
        const i = document.createElement("div");
        i.classList.add("cm-foldMarker");
        const d = M(C, {
          icon: s ? "ChevronDown" : "ChevronRight",
          size: "xs"
        });
        return S(d, i), i;
      }
    })
  ), l && w[l] && (r.push(w[l]()), v || r.push(
    E({
      markerDOM: (s) => {
        const i = document.createElement("div");
        i.classList.add("cm-foldMarker");
        const d = M(C, {
          icon: s ? "ChevronDown" : "ChevronRight",
          size: "xs"
        });
        return S(d, i), i;
      }
    })
  )), R && l === "json") {
    const s = X((i) => {
      const d = [], y = i.state.doc.toString();
      if (y.trim())
        try {
          JSON.parse(y);
        } catch (k) {
          k instanceof Error && d.push({
            from: 0,
            to: i.state.doc.length,
            severity: "error",
            message: k.message
          });
        }
      return d;
    });
    r.push(s);
  }
  return N && r.push(ne()), O ? r.push(
    u.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ) : r.push(
    u.of([
      {
        key: "Enter",
        run: V
      }
    ])
  ), r;
}
export {
  xe as useCodeMirror
};
